using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

using java.util.zip;

namespace CsZip
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu appMainMenu;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.ListView zipListView;
		private System.Windows.Forms.StatusBar appStatusBar;
		private System.Windows.Forms.OpenFileDialog zipOpenFileDialog;
		private System.Windows.Forms.SaveFileDialog zipSaveFileDialog;
		private System.Windows.Forms.MenuItem fileMenuItem;
		private System.Windows.Forms.MenuItem newMenuItem;
		private System.Windows.Forms.MenuItem openMenuItem;
		private System.Windows.Forms.MenuItem exitMenuItem;
		private System.Windows.Forms.MenuItem actionsMenuItem;
		private System.Windows.Forms.MenuItem addMenuItem;
		private System.Windows.Forms.MenuItem deleteMenuItem;
		private System.Windows.Forms.MenuItem extractMenuItem;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private System.Windows.Forms.ColumnHeader columnHeader4;
		private System.Windows.Forms.OpenFileDialog addOpenFileDialog;
		private System.Windows.Forms.MenuItem editMenuItem;
		private System.Windows.Forms.MenuItem selectAllMenuItem;
		private System.Windows.Forms.MenuItem invertSelMenuItem;
		private System.Windows.Forms.ImageList zipImageList;
		private System.ComponentModel.IContainer components;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			CurrentFile = null;

			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.appMainMenu = new System.Windows.Forms.MainMenu();
			this.fileMenuItem = new System.Windows.Forms.MenuItem();
			this.newMenuItem = new System.Windows.Forms.MenuItem();
			this.openMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.exitMenuItem = new System.Windows.Forms.MenuItem();
			this.editMenuItem = new System.Windows.Forms.MenuItem();
			this.selectAllMenuItem = new System.Windows.Forms.MenuItem();
			this.invertSelMenuItem = new System.Windows.Forms.MenuItem();
			this.actionsMenuItem = new System.Windows.Forms.MenuItem();
			this.addMenuItem = new System.Windows.Forms.MenuItem();
			this.deleteMenuItem = new System.Windows.Forms.MenuItem();
			this.extractMenuItem = new System.Windows.Forms.MenuItem();
			this.zipListView = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.appStatusBar = new System.Windows.Forms.StatusBar();
			this.zipOpenFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.zipSaveFileDialog = new System.Windows.Forms.SaveFileDialog();
			this.addOpenFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.zipImageList = new System.Windows.Forms.ImageList(this.components);
			this.SuspendLayout();
			// 
			// appMainMenu
			// 
			this.appMainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						this.fileMenuItem,
																						this.editMenuItem,
																						this.actionsMenuItem});
			// 
			// fileMenuItem
			// 
			this.fileMenuItem.Index = 0;
			this.fileMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.newMenuItem,
																						 this.openMenuItem,
																						 this.menuItem4,
																						 this.exitMenuItem});
			this.fileMenuItem.Text = "&File";
			// 
			// newMenuItem
			// 
			this.newMenuItem.Index = 0;
			this.newMenuItem.Text = "&New Archive...";
			this.newMenuItem.Click += new System.EventHandler(this.newMenuItem_Click);
			// 
			// openMenuItem
			// 
			this.openMenuItem.Index = 1;
			this.openMenuItem.Text = "&Open Archive...";
			this.openMenuItem.Click += new System.EventHandler(this.openMenuItem_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "-";
			// 
			// exitMenuItem
			// 
			this.exitMenuItem.Index = 3;
			this.exitMenuItem.Text = "E&xit";
			this.exitMenuItem.Click += new System.EventHandler(this.exitMenuItem_Click);
			// 
			// editMenuItem
			// 
			this.editMenuItem.Index = 1;
			this.editMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.selectAllMenuItem,
																						 this.invertSelMenuItem});
			this.editMenuItem.Text = "&Edit";
			// 
			// selectAllMenuItem
			// 
			this.selectAllMenuItem.Index = 0;
			this.selectAllMenuItem.Text = "Select &All";
			this.selectAllMenuItem.Click += new System.EventHandler(this.selectAllMenuItem_Click);
			// 
			// invertSelMenuItem
			// 
			this.invertSelMenuItem.Index = 1;
			this.invertSelMenuItem.Text = "&Invert Selection";
			this.invertSelMenuItem.Click += new System.EventHandler(this.invertSelMenuItem_Click);
			// 
			// actionsMenuItem
			// 
			this.actionsMenuItem.Index = 2;
			this.actionsMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							this.addMenuItem,
																							this.deleteMenuItem,
																							this.extractMenuItem});
			this.actionsMenuItem.Text = "&Actions";
			this.actionsMenuItem.Popup += new System.EventHandler(this.actionsMenuItem_Popup);
			// 
			// addMenuItem
			// 
			this.addMenuItem.Index = 0;
			this.addMenuItem.Text = "&Add...";
			this.addMenuItem.Click += new System.EventHandler(this.addMenuItem_Click);
			// 
			// deleteMenuItem
			// 
			this.deleteMenuItem.Index = 1;
			this.deleteMenuItem.Text = "&Delete...";
			this.deleteMenuItem.Click += new System.EventHandler(this.deleteMenuItem_Click);
			// 
			// extractMenuItem
			// 
			this.extractMenuItem.Index = 2;
			this.extractMenuItem.Text = "&Extract...";
			this.extractMenuItem.Click += new System.EventHandler(this.extractMenuItem_Click);
			// 
			// zipListView
			// 
			this.zipListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						  this.columnHeader1,
																						  this.columnHeader2,
																						  this.columnHeader3,
																						  this.columnHeader4});
			this.zipListView.Dock = System.Windows.Forms.DockStyle.Fill;
			this.zipListView.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.zipListView.Name = "zipListView";
			this.zipListView.Size = new System.Drawing.Size(528, 279);
			this.zipListView.SmallImageList = this.zipImageList;
			this.zipListView.Sorting = System.Windows.Forms.SortOrder.Ascending;
			this.zipListView.TabIndex = 0;
			this.zipListView.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Name";
			this.columnHeader1.Width = 160;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Size";
			// 
			// columnHeader3
			// 
			this.columnHeader3.Text = "Packed";
			// 
			// columnHeader4
			// 
			this.columnHeader4.Text = "Path";
			this.columnHeader4.Width = 240;
			// 
			// appStatusBar
			// 
			this.appStatusBar.Location = new System.Drawing.Point(0, 279);
			this.appStatusBar.Name = "appStatusBar";
			this.appStatusBar.Size = new System.Drawing.Size(528, 22);
			this.appStatusBar.TabIndex = 1;
			// 
			// zipOpenFileDialog
			// 
			this.zipOpenFileDialog.DefaultExt = "zip";
			this.zipOpenFileDialog.Filter = "Zip files|*.zip";
			// 
			// zipSaveFileDialog
			// 
			this.zipSaveFileDialog.DefaultExt = "zip";
			this.zipSaveFileDialog.FileName = "doc1";
			this.zipSaveFileDialog.Filter = "Zip files|*.zip";
			// 
			// addOpenFileDialog
			// 
			this.addOpenFileDialog.Filter = "Any file|*.*";
			this.addOpenFileDialog.Multiselect = true;
			// 
			// zipImageList
			// 
			this.zipImageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.zipImageList.ImageSize = new System.Drawing.Size(16, 16);
			this.zipImageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 301);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.zipListView,
																		  this.appStatusBar});
			this.Menu = this.appMainMenu;
			this.Name = "MainForm";
			this.Text = "SharpZip";
			this.ResumeLayout(false);

		}
		#endregion

		private ZipFile m_CurrentFile; 
		private ZipFile CurrentFile
		{
			get { return m_CurrentFile; }
			set
			{
				if (m_CurrentFile != null)
					m_CurrentFile.close();
				m_CurrentFile = value;
				if (m_CurrentFile != null)
				{
					DisplayEntries();
					Text = "SharpZip - " + m_CurrentFile.getName();
				}
				else
					Text = "SharpZip";
			}
		}

		private void DisplayEntries()
		{
			zipListView.BeginUpdate();
			try
			{
				zipImageList.Images.Clear();
				zipListView.Items.Clear();
				ListDictionary imgs = new ListDictionary();
				foreach(ZipEntry entry in new EnumerationAdapter(new EnumerationMethod(CurrentFile.entries)))
				{
					if (!entry.isDirectory())
					{
						string name = entry.getName();
						ListViewItem item = new ListViewItem(Path.GetFileName(name));
						item.SubItems.Add(entry.getSize().ToString());
						item.SubItems.Add(entry.getCompressedSize().ToString());
						item.SubItems.Add(Path.GetDirectoryName(name));
						item.Tag = entry;

						string ext = Path.GetExtension(name);
						if (imgs[ext] == null)
						{
							Icon ic = IconFromFileType(name);
							if (ic != null)
							{
								zipImageList.Images.Add(ic);
								imgs[ext] = zipImageList.Images.Count - 1; // store image index
							}
						}
						if (imgs[ext] != null)
							item.ImageIndex = (int)imgs[ext];

						zipListView.Items.Add(item);
					}
				}
			}
			finally
			{
				zipListView.EndUpdate();
			}
		}

		private bool IsEntrySelected(ZipEntry e)
		{
			bool Result = false;
			for(int i = 0; i < zipListView.SelectedItems.Count && !Result; i++)
			{
				ZipEntry e1 = (ZipEntry)zipListView.SelectedItems[i].Tag;
				Result = e1.getName() == e.getName();
			}
			return Result;
		}

		private bool IsEntryUnselected(ZipEntry e)
		{
			return !IsEntrySelected(e);
		}

		private int GetWin32IntConstant(string name)
		{
			System.Reflection.Assembly asm = System.Reflection.Assembly.GetAssembly(typeof(com.ms.win32.wina));
			Type t = asm.GetType("com.ms.win32.win" + char.ToLower(name[0]), true);
			System.Reflection.FieldInfo info = t.GetField(name);
			return int.Parse(info.GetValue(null).ToString());
		}

		private Icon IconFromFileType(string path)
		{
			Icon Result = null;
			com.ms.win32.SHFILEINFO info = new com.ms.win32.SHFILEINFO();

			int flags = GetWin32IntConstant("SHGFI_ICON") | GetWin32IntConstant("SHGFI_USEFILEATTRIBUTES") | GetWin32IntConstant("SHGFI_SMALLICON");
			if (com.ms.win32.Shell32.SHGetFileInfo(path, 0, info, 1024 /* struct size */, flags) != 0)
			{
				Icon tmp = Icon.FromHandle(new IntPtr(info.hIcon)); // the Icon does not own the handle...
				try
				{
					// ...that's why we copy it
					Result = new Icon(tmp, tmp.Size);
					tmp.Dispose();
				}
				finally
				{
					com.ms.win32.User32.DestroyIcon(info.hIcon);
				}
			}
			return Result;
		}

		private void exitMenuItem_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void newMenuItem_Click(object sender, System.EventArgs e)
		{
			if (zipSaveFileDialog.ShowDialog() == DialogResult.OK)
				CurrentFile = ZipUtils.CreateEmptyZipFile(zipSaveFileDialog.FileName);
		}

		private void openMenuItem_Click(object sender, System.EventArgs e)
		{
			if (zipOpenFileDialog.ShowDialog() == DialogResult.OK)
				CurrentFile = new ZipFile(zipOpenFileDialog.FileName);
		}

		private void actionsMenuItem_Popup(object sender, System.EventArgs e)
		{
			addMenuItem.Enabled = CurrentFile != null;
			deleteMenuItem.Enabled = CurrentFile != null && zipListView.SelectedItems.Count > 0;
			extractMenuItem.Enabled = CurrentFile != null && zipListView.Items.Count > 0;
		}

		private void addMenuItem_Click(object sender, System.EventArgs e)
		{
			if (addOpenFileDialog.ShowDialog() == DialogResult.OK)
				CurrentFile = ZipUtils.UpdateZipFile(CurrentFile, null, addOpenFileDialog.FileNames);
		}

		private void deleteMenuItem_Click(object sender, System.EventArgs e)
		{
			if (MessageBox.Show(this, "Do you want to delete the selected files?", Text, MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation) == DialogResult.OK)
				CurrentFile = ZipUtils.UpdateZipFile(CurrentFile, new FilterEntryMethod(IsEntryUnselected), null);
		}

		private void extractMenuItem_Click(object sender, System.EventArgs e)
		{
			string msg = zipListView.SelectedItems.Count == 0 ? "Select the directory to which you want to extract all files." : "Select the directory to which you want to extract the selected files.";
			FolderDialog dlg = new FolderDialog(msg);
			if (dlg.ShowDialog() == DialogResult.OK)
				ZipUtils.ExtractZipFile(CurrentFile, dlg.Path, zipListView.SelectedItems.Count > 0 ? new FilterEntryMethod(IsEntrySelected) : null);
		}

		private void selectAllMenuItem_Click(object sender, System.EventArgs e)
		{
			foreach(ListViewItem item in zipListView.Items)
				item.Selected = true;
		}

		private void invertSelMenuItem_Click(object sender, System.EventArgs e)
		{
			foreach(ListViewItem item in zipListView.Items)
				item.Selected = !item.Selected;
		}
	}
}
